<script type="text/javascript">
  (async function() {
    if (!window.dimPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimPromise = prom;
      /* will be resolved by DimConf script */
    }

    const nodeTemplate = {
      nodeName: {
        property: "name",
        label: RED._('node-red-dim/disValue:disValue.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim/disValue:disValue.label.node-conf')
      },
      serviceName: {
        property: "serviceName",
        label: RED._('node-red-dim/disValue:disValue.label.service-name')
      },
      serviceDefinitions: [
        {
          property: "serviceDef",
          label: RED._('node-red-dim/disValue:disValue.label.service-definition')
        }
      ],
      stdInputs: [
        {
          property: "value",
          label: RED._('node-red-dim/disValue:disValue.label.value')
        }
      ]
    };

    const nodeLabel = function(node, dflt) {
      let def = "";
      if (node.serviceName) {
        if (!node.hasOwnProperty('serviceDef')) { /* DIS JSON node */
          def = " [ C ]";
        }
        else if (node.serviceDef) { /* DIM VALUE SERVER node */
          def = " [ " + node.serviceDef + " ]";
        }
      }
      return node.name || node.serviceName + def || dflt;
    };

    /* -- DIM Value Server -- */
    const dim = await dimPromise.promise;
    dim.utils.genNodeTemplate("dim-value-server", nodeTemplate);

    const disValueDef = {
      category: 'network',
      color: '#F3B567',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(dis.regExp.srvName)
        },
        serviceDef: { value: "", required: true,
          validate: function(d) {
            if (!d) { return false; }

            const res = d.match(dis.regExp.srvDefDescr);
            if (res) {
              d = d.slice(0, res.index); /* extract service definition */
              $('#node-input-serviceDef').val(d);
            }
            return dis.regExp.srvDefFormat.test(d);
          }
        },
        value: { value: "", required: true }
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 1,
      label: function() {
        return nodeLabel(this, "DIM Value Server")
      }
    };

    RED.nodes.registerType("dim-value-server", disValueDef);

    /* -- DIM JSON Server -- */
    disJsonTmp = { ...nodeTemplate };
    delete disJsonTmp.serviceDefinitions;
    dim.utils.genNodeTemplate("dim-json-server", disJsonTmp);

    /* deep clone of dim-value-server node definition */
    disJsonDef = $.extend(true, {}, disValueDef);

    /* service definition is known (C - string) */
    delete disJsonDef.defaults.serviceDef;

    disJsonDef.label = function() {
      return nodeLabel(this, "DIM JSON Server")
    };
    RED.nodes.registerType("dim-json-server", disJsonDef);
  }());
</script>

<script type="text/html" data-template-name="dim-value-server"></script>

<script type="text/html" data-template-name="dim-json-server"></script>
